//----------------------------------------------------------------------------------
//aviutlvOC C^Ȓጸ(LPF)
//
//----------------------------------------------------------------------------------
#include <windows.h>
#include <mmintrin.h>

#include "filter.h"

// ֐
int lpf_v_3(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_5(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_7(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_9(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_11(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_13(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_15(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_3_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_5_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_7_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_9_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_11_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_13_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int lpf_v_15_mmx(PIXEL_YC *, PIXEL_YC *, int, int, int, int, int);
int (*lpf_v[])(PIXEL_YC*, PIXEL_YC*, int, int, int, int, int)
 = { lpf_v_3,     lpf_v_5,     lpf_v_7,     lpf_v_9,     lpf_v_11,    lpf_v_13,     lpf_v_15,
     lpf_v_3_mmx, lpf_v_5_mmx, lpf_v_7_mmx, lpf_v_9_mmx, lpf_v_11_mmx,lpf_v_13_mmx, lpf_v_15_mmx };


//---------------------------------------------------------------------
//tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 3 //gbNo[̐
TCHAR *track_name[] = {"tap", "", "" }; //gbNo[̖O
int   track_default[] = { 0, 0, 0 }; //gbNo[̏l
int   track_s[] = { 0, 0 , 0 }; //gbNo[̉l
int   track_e[] = { 6, 64, 64 }; //gbNo[̏l
enum  { T_TAP, T_TOP, T_BTM };

#define CHECK_N 1 //`FbN{bNX̐
TCHAR *check_name[] = { "MMX" }; //`FbN{bNX̖O
int    check_default[] = { 1 }; //`FbN{bNX̏l (l01)
enum { C_MMX };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, //| FILTER_FLAG_WINDOW_SIZE, //tB^̃tO
  0,0,                        //ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
  "C^Ȓጸ", //tB^̖O
  TRACK_N,                    //gbNo[̐ (0Ȃ疼OlNULLł悢)
  track_name,                 //gbNo[̖OSւ̃|C^
  track_default,              //gbNo[̏lSւ̃|C^
  track_s,track_e,            //gbNo[̐l̉ (NULLȂS0`256)
  CHECK_N,                    //`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
  check_name,                 //`FbN{bNX̖OSւ̃|C^
  check_default,              //`FbN{bNX̏lSւ̃|C^
  func_proc,                  //tB^֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                  //JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,NULL,                  //VXeŎg܂̂ŎgpȂł
  NULL,                       //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  0,                       //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  "lpf_decomb by N099, ver1.2",  //  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
  NULL,                       //Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)

};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
  int fnum;

  fnum = fp->track[T_TAP];
  fnum += fp->check[C_MMX] * (track_e[T_TAP] + 1);
  if(0 == lpf_v[fnum]( fpip->ycp_temp, fpip->ycp_edit,
                       fpip->h,
                       fp->track[T_TOP], fp->track[T_BTM],
                       fpip->max_w, fpip->w ))
    {
      PIXEL_YC *ycp;
      
      ycp = fpip->ycp_temp;
      fpip->ycp_temp = fpip->ycp_edit;
      fpip->ycp_edit = ycp;
      return TRUE;
    }

  return FALSE;
}

// 3tap LPF
// ht Jn, hbAI荂
int lpf_v_3(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l2;
  short *src0, *src1, *src2, *dst0;
  short tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l0 = i>0 ? i-1 : 0;
    l2 = i<(h-1) ? i+1 : h-1;

    dst0 = (short *)(dst + i * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + i * max_w);
    src2 = (short *)(src + l2 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src1, max_w * sizeof(PIXEL_YC));
      continue;
    }
      
    for(j=0; j<w; ++j){
      tmp = *src0 + *src2;
      tmp += *src1*2 + 2;
      *dst0 = tmp >> 2;

      src0++;
      src1++;
      src2++;
      dst0++;
    }
  }

  return 0;
}

// 5tap LPF
int lpf_v_5(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l3,l4;
  short *src0, *src1, *src2, *src3, *src4, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l1 = i>0 ? i-1 : 0;
    l3 = i<(h-1) ? i+1 : h-1;
    l0 = (i-1)>0 ? i-2 : l1;
    l4 = i<(h-2) ? i+2 : l3;
    
    dst0 = (short *)(dst + i * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + i  * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + l4 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src2, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *src4;
      tmp = (*src1 + *src3) * 8192 - (tmp * 2606);
      *dst0 = (tmp + *src2 * 21596 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      dst0++;
    }
  }

  return 0;
}

// 7tap LPF
int lpf_v_7(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l2,l4,l5,l6;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l2 = i>0 ? i-1 : 0;
    l4 = i<(h-1) ? i+1 : h-1;
    l1 = (i-1)>0 ? i-2 : l2;
    l5 = i<(h-2) ? i+2 : l4;
    l0 = (i-2)>0 ? i-3 : l1;
    l6 = i<(h-3) ? i+3 : l5;

    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + i  * max_w);
    src4 = (short *)(src + l4 * max_w);
    src5 = (short *)(src + l5 * max_w);
    src6 = (short *)(src + l6 * max_w);
    
    if(i<ht || i>hb){
      memcpy(dst0, src3, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *src6;
      tmp = (*src1 + *src5) * 4000 - (tmp * 1315);
      tmp = (*src2 + *src4) * 6876 - tmp;
      *dst0 = (tmp + *src3 * 24386 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      dst0++;
    }
  }

  return 0;
}

// 9tap LPF
int lpf_v_9(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
   int i,j;
  int l0,l1,l2,l3,l5,l6,l7,l8;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *src7, *src8, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l3 = i>0 ? i-1 : 0;
    l5 = i<(h-1) ? i+1 : h-1;
    l2 = (i-1)>0 ? i-2 : l3;
    l6 = i<(h-2) ? i+2 : l5;
    l1 = (i-2)>0 ? i-3 : l2;
    l7 = i<(h-3) ? i+3 : l6;
    l0 = (i-3)>0 ? i-4 : l1;
    l8 = i<(h-4) ? i+4 : l7;

    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + i  * max_w);
    src5 = (short *)(src + l5 * max_w);
    src6 = (short *)(src + l6 * max_w);
    src7 = (short *)(src + l7 * max_w);
    src8 = (short *)(src + l8 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src4, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *src8;
      tmp = (*src1 + *src7) * 2285 - (tmp * 766);
      tmp = (*src2 + *src6) * 4237 - tmp;
      tmp = (*src3 + *src5) * 5907 - tmp;
      *dst0 = (tmp + *src4 * 26390 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;      
      dst0++;
    }
  }

  return 0;
}

// 11tap LPF
int lpf_v_11(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
   int i,j;
  int l0,l1,l2,l3,l4,l6,l7,l8,l9,la;
  short *src0, *src1, *src2, *src3, *src4, *src5;
  short *src6, *src7, *src8, *src9, *srca, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l4 = i>0 ? i-1 : 0;
    l6 = i<(h-1) ? i+1 : h-1;
    l3 = (i-1)>0 ? i-2 : l4;
    l7 = i<(h-2) ? i+2 : l6;
    l2 = (i-2)>0 ? i-3 : l3;
    l8 = i<(h-3) ? i+3 : l7;
    l1 = (i-3)>0 ? i-4 : l2;
    l9 = i<(h-4) ? i+4 : l8;
    l0 = (i-4)>0 ? i-5 : l1;
    la = i<(h-5) ? i+5 : l9;    

    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + l4 * max_w);
    src5 = (short *)(src + i  * max_w);
    src6 = (short *)(src + l6 * max_w);
    src7 = (short *)(src + l7 * max_w);
    src8 = (short *)(src + l8 * max_w);
    src9 = (short *)(src + l9 * max_w);
    srca = (short *)(src + la * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src5, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *srca;
      tmp = (*src1 + *src9) * 1442 - (tmp * 518);
      tmp = (*src2 + *src8) * 2693 - tmp;
      tmp = (*src3 + *src7) * 3993 - tmp;
      tmp = (*src4 + *src6) * 4980 - tmp;
      *dst0 = (tmp + *src5 * 27256 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;
      src9++;
      srca++;     
      dst0++;
    }
  }

  return 0;
}

// 13tap LPF
int lpf_v_13(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l2,l3,l4,l5,l7,l8,l9,la,lb,lc;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6;
  short *src7, *src8, *src9, *srca, *srcb, *srcc, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l5 = i>0 ? i-1 : 0;
    l7 = i<(h-1) ? i+1 : h-1;
    l4 = (i-1)>0 ? i-2 : l5;
    l8 = i<(h-2) ? i+2 : l7;
    l3 = (i-2)>0 ? i-3 : l4;
    l9 = i<(h-3) ? i+3 : l8;
    l2 = (i-3)>0 ? i-4 : l3;
    la = i<(h-4) ? i+4 : l9;
    l1 = (i-4)>0 ? i-5 : l2;
    lb = i<(h-5) ? i+5 : la;    
    l0 = (i-5)>0 ? i-6 : l1;
    lc = i<(h-6) ? i+6 : lb;
    
    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + l4 * max_w);
    src5 = (short *)(src + l5 * max_w);
    src6 = (short *)(src + i  * max_w);
    src7 = (short *)(src + l7 * max_w);
    src8 = (short *)(src + l8 * max_w);
    src9 = (short *)(src + l9 * max_w);
    srca = (short *)(src + la * max_w);
    srcb = (short *)(src + lb * max_w);
    srcc = (short *)(src + lc * max_w);
    
    if(i<ht || i>hb){
      memcpy(dst0, src5, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *srcc;
      tmp = (*src1 + *srcb) * 981 - (tmp * 363);
      tmp = (*src2 + *srca) * 1841 - tmp;
      tmp = (*src3 + *src9) * 2822 - tmp;
      tmp = (*src4 + *src8) * 3737 - tmp;
      tmp = (*src5 + *src7) * 4389 - tmp;
      *dst0 = (tmp + *src6 * 28266 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;
      src9++;
      srca++;
      srcb++;
      srcc++;     
      dst0++;
    }
  }

  return 0;
}

// 15tap LPF
int lpf_v_15(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l2,l3,l4,l5,l6,l8,l9,la,lb,lc,ld,le;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *src7;
  short *src8, *src9, *srca, *srcb, *srcc, *srcd, *srce, *dst0;
  int tmp;

  w *= (sizeof(PIXEL_YC) / sizeof(short));
  hb = h - hb;

  for(i=0; i<h; i++){
    l6 = i>0 ? i-1 : 0;
    l8 = i<(h-1) ? i+1 : h-1;
    l5 = (i-1)>0 ? i-2 : l6;
    l9 = i<(h-2) ? i+2 : l8;
    l4 = (i-2)>0 ? i-3 : l5;
    la = i<(h-3) ? i+3 : l9;
    l3 = (i-3)>0 ? i-4 : l4;
    lb = i<(h-4) ? i+4 : la;
    l2 = (i-4)>0 ? i-5 : l3;
    lc = i<(h-5) ? i+5 : lb;    
    l1 = (i-5)>0 ? i-6 : l2;
    ld = i<(h-6) ? i+6 : lc;
    l0 = (i-5)>0 ? i-7 : l1;
    le = i<(h-6) ? i+7 : ld;
    
    dst0 = (short *)(dst + i  * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + l2 * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + l4 * max_w);
    src5 = (short *)(src + l5 * max_w);
    src6 = (short *)(src + l6 * max_w);
    src7 = (short *)(src + i  * max_w);
    src8 = (short *)(src + l8 * max_w);
    src9 = (short *)(src + l9 * max_w);
    srca = (short *)(src + la * max_w);
    srcb = (short *)(src + lb * max_w);
    srcc = (short *)(src + lc * max_w);
    srcd = (short *)(src + ld * max_w);
    srce = (short *)(src + le * max_w);
    
    if(i<ht || i>hb){
      memcpy(dst0, src5, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=0; j<w; ++j){
      tmp = *src0 + *srce;
      tmp = (*src1 + *srcd) * 695 - (tmp * 265);
      tmp = (*src2 + *srcc) * 1299 - tmp;
      tmp = (*src3 + *srcb) * 2021 - tmp;
      tmp = (*src4 + *srca) * 2766 - tmp;
      tmp = (*src5 + *src9) * 3417 - tmp;
      tmp = (*src6 + *src8) * 3862 - tmp;
      *dst0 = (tmp + *src7 * 28650 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;
      src9++;
      srca++;
      srcb++;
      srcc++;
      srcd++;
      srce++;
      dst0++;
    }
  }

  return 0;
}

// 3tap LPF w/ MMX
// ht Jn, hbAI荂
int lpf_v_3_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l2;
  short *src0, *src1, *src2, *dst0;
  short tmp;
  __m64 s0, s1, s2, c0;

  c0 = _mm_set1_pi16(2);
  hb = h - hb;
  w  = w * (sizeof(PIXEL_YC) / sizeof(short));
  
  for(i=0; i<h; i++){
    l0 = i>0 ? i-1 : 0;
    l2 = i<(h-1) ? i+1 : h-1;

    dst0 = (short *)(dst + i * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + i * max_w);
    src2 = (short *)(src + l2 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src1, max_w * sizeof(PIXEL_YC));
      continue;
    }
      
    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      s1 = *(__m64 *)src1;
      s2 = *(__m64 *)src2;
      s0 = _mm_adds_pi16(s0, s2);
      s1 = _mm_slli_pi16(s1, 1);
      s0 = _mm_adds_pi16(s0, c0);
      s1 = _mm_adds_pi16(s1, s0);
      *(__m64 *)dst0 = _mm_srai_pi16(s1, 2);

      src0 += 4;
      src1 += 4;
      src2 += 4;
      dst0 += 4;
    }
    //c
    for( ; j>0; --j){
      tmp = *src0 + *src2;
      tmp += *src1*2 + tmp + 2;
      *dst0 = tmp >> 2;

      src0++;
      src1++;
      src2++;
      dst0++;
    }
  }

  _mm_empty();
  
  return 0;
}

// 5tap LPF w/ MMX
int lpf_v_5_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l3,l4;
  short *src0, *src1, *src2, *src3, *src4, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, c0, c1, c2;
  
  c0 = _mm_set_pi16(-2606, 8192, -2606, 8192);
  c1 = _mm_set_pi16(21596, 0, 21596, 0);
  c2 = _mm_set1_pi32(1<<14);
  hb = h - hb;
  w  = w * (sizeof(PIXEL_YC) / sizeof(short));

  for(i=0; i<h; i++){
    l1 = i>0 ? i-1 : 0;
    l3 = i<(h-1) ? i+1 : h-1;
    l0 = (i-1)>0 ? i-2 : l1;
    l4 = i<(h-2) ? i+2 : l3;
    
    dst0 = (short *)(dst + i * max_w);
    src0 = (short *)(src + l0 * max_w);
    src1 = (short *)(src + l1 * max_w);
    src2 = (short *)(src + i  * max_w);
    src3 = (short *)(src + l3 * max_w);
    src4 = (short *)(src + l4 * max_w);

    if(i<ht || i>hb){
      memcpy(dst0, src2, max_w * sizeof(PIXEL_YC));
      continue;
    }
    
    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      s1 = *(__m64 *)src1;
      s2 = *(__m64 *)src2;
      s3 = *(__m64 *)src3;
      s4 = *(__m64 *)src4;

      s0 = _mm_adds_pi16(s0, s4);
      s1 = _mm_adds_pi16(s1, s3);

      s4 = _mm_unpackhi_pi16(s1, s0);
      s3 = _mm_unpacklo_pi16(s1, s0);

      s4 = _mm_madd_pi16(s4, c0);
      s3 = _mm_madd_pi16(s3, c0);

      s0 = _mm_unpackhi_pi16(s0, s2);
      s1 = _mm_unpacklo_pi16(s1, s2);

      s0 = _mm_madd_pi16(s0, c1);
      s1 = _mm_madd_pi16(s1, c1);

      s0 = _mm_add_pi32(s0, s4);
      s1 = _mm_add_pi32(s1, s3);

      s0 = _mm_add_pi32(s0, c2);
      s1 = _mm_add_pi32(s1, c2);

      s0 = _mm_srai_pi32(s0, 15);
      s1 = _mm_srai_pi32(s1, 15);

      s2 = _mm_packs_pi32(s1, s0);
      *(__m64 *)dst0 = s2;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      dst0 += 4;
    }
    //̂
    for( ; j>0; --j){
      tmp = *src0 + *src4;
      tmp = (*src1 + *src3) * 8192 - (tmp * 2606);
      *dst0 = (tmp + *src2 * 21596 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      dst0++;
    }
  }

  _mm_empty();

  return 0;
}


// 7tap LPF w/ MMX
int lpf_v_7_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l2,l4,l5,l6;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, s5, s6, c0, c1;
  
  c0 = _mm_set_pi16(1315, -4000, 1315, -4000);
  c1 = _mm_set_pi16(24386, 6876, 24386, 6876);
  hb = h - hb;
  w  = w * (sizeof(PIXEL_YC) / sizeof(short));

  for(i=0; i<ht; i++){
    dst0 = (short *)(dst + i * max_w);
    src3 = (short *)(src + i * max_w);
    memcpy(dst0, src3, max_w * sizeof(PIXEL_YC));
  }
  for( ; i<hb; i++){
    dst0 = (short *)(dst + i * max_w);
    src3 = (short *)(src + i * max_w);
    if(i-3<0 || i+3>=h){ //͈͊OQƂꍇ
      l2 = i>0 ? i-1 : 0;
      l4 = i<(h-1) ? i+1 : h-1;
      l1 = (i-1)>0 ? i-2 : l2;
      l5 = i<(h-2) ? i+2 : l4;
      l0 = (i-2)>0 ? i-3 : l1;
      l6 = i<(h-3) ? i+3 : l5;

      src0 = (short *)(src + l0 * max_w);
      src1 = (short *)(src + l1 * max_w);
      src2 = (short *)(src + l2 * max_w);
      src4 = (short *)(src + l4 * max_w);
      src5 = (short *)(src + l5 * max_w);
      src6 = (short *)(src + l6 * max_w);
    }else{ //͈͊OQƂȂ
      src0 = (short *)(src + (i-3) * max_w);
      src1 = (short *)(src + (i-2) * max_w);
      src2 = (short *)(src + (i-1) * max_w);
      src4 = (short *)(src + (i+1) * max_w);
      src5 = (short *)(src + (i+2) * max_w);
      src6 = (short *)(src + (i+3) * max_w);
    }
    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      s6 = *(__m64 *)src6;
      s0 = _mm_adds_pi16(s0, s6); 
     
      s1 = *(__m64 *)src1;
      s5 = *(__m64 *)src5;
      s1 = _mm_adds_pi16(s1, s5);
      
      s6 = _mm_unpackhi_pi16(s1, s0);
      s1 = _mm_unpacklo_pi16(s1, s0);

      s6 = _mm_madd_pi16(s6, c0);
      s1 = _mm_madd_pi16(s1, c0);

      //
      s0 = _mm_cmpeq_pi32(s0, s0);
      s0 = _mm_srli_pi32(s0, 31);
      s0 = _mm_slli_pi32(s0, 14);

      s6 = _mm_add_pi32(s6, s0);
      s1 = _mm_add_pi32(s1, s0);
      
      s2 = *(__m64 *)src2;
      s4 = *(__m64 *)src4;
      s2 = _mm_adds_pi16(s2, s4);
      
      s3 = *(__m64 *)src3;   

      s4 = _mm_unpackhi_pi16(s2, s3);
      s2 = _mm_unpacklo_pi16(s2, s3);
      
      s4 = _mm_madd_pi16(s4, c1);
      s2 = _mm_madd_pi16(s2, c1);

      s6 = _mm_add_pi32(s6, s4);
      s1 = _mm_add_pi32(s1, s2);
      
      s6 = _mm_srai_pi32(s6, 15);
      s1 = _mm_srai_pi32(s1, 15);

      s1 = _mm_packs_pi32(s1, s6);
      *(__m64 *)dst0 = s1;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      src5 += 4;
      src6 += 4;
      dst0 += 4;
    }
    //c
    for( ; j>0; --j){
      tmp = *src0 + *src6;
      tmp = (*src1 + *src5) * 4000 - (tmp * 1315);
      tmp = (*src2 + *src4) * 6876 - tmp;
      *dst0 = (tmp + *src3 * 24386 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      dst0++;
    }
  }
  for( ; i<h; i++){
    dst0 = (short *)(dst + i * max_w);
    src3 = (short *)(src + i * max_w);
    memcpy(dst0, src3, max_w * sizeof(PIXEL_YC));
  }

  _mm_empty();

  return 0;
}

// 9tap LPF w/ MMX
int lpf_v_9_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
   int i,j;
  int l0,l1,l2,l3,l5,l6,l7,l8;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *src7, *src8, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, s5, s6, s7, s8, c0, c1, c2;
  
  c0 = _mm_set_pi16(-766, 2285, -766, 2285);
  c1 = _mm_set_pi16(-4237, 5907, -4237, 5907);
  c2 = _mm_set_pi16(26390, 1<<14, 26390, 1<<14);
  hb = h - hb;
  w  = w * (sizeof(PIXEL_YC) / sizeof(short));
  
  for(i=0; i<ht; i++){
    dst0 = (short *)(dst + i * max_w);
    src4 = (short *)(src + i * max_w);
    memcpy(dst0, src4, max_w * sizeof(PIXEL_YC));
  }
  for( ; i<hb; i++){
    dst0 = (short *)(dst + i  * max_w);
    src4 = (short *)(src + i  * max_w);
    if(i-4<0 || i+4>=h){ //͈͊OQƂꍇ
      l3 = i>0 ? i-1 : 0;
      l5 = i<(h-1) ? i+1 : h-1;
      l2 = (i-1)>0 ? i-2 : l3;
      l6 = i<(h-2) ? i+2 : l5;
      l1 = (i-2)>0 ? i-3 : l2;
      l7 = i<(h-3) ? i+3 : l6;
      l0 = (i-3)>0 ? i-4 : l1;
      l8 = i<(h-4) ? i+4 : l7;

      src0 = (short *)(src + l0 * max_w);
      src1 = (short *)(src + l1 * max_w);
      src2 = (short *)(src + l2 * max_w);
      src3 = (short *)(src + l3 * max_w);
      src5 = (short *)(src + l5 * max_w);
      src6 = (short *)(src + l6 * max_w);
      src7 = (short *)(src + l7 * max_w);
      src8 = (short *)(src + l8 * max_w);
    }else{
      src0 = (short *)(src + (i-4) * max_w);
      src1 = (short *)(src + (i-3) * max_w);
      src2 = (short *)(src + (i-2) * max_w);
      src3 = (short *)(src + (i-1) * max_w);
      src5 = (short *)(src + (i+1) * max_w);
      src6 = (short *)(src + (i+2) * max_w);
      src7 = (short *)(src + (i+3) * max_w);
      src8 = (short *)(src + (i+4) * max_w);
    }

    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      s8 = *(__m64 *)src8;

      s0 = _mm_adds_pi16(s0, s8);

      s1 = *(__m64 *)src1;
      s7 = *(__m64 *)src7;
      
      s1 = _mm_adds_pi16(s1, s7);

      s8 = _mm_unpackhi_pi16(s1, s0);
      s1 = _mm_unpacklo_pi16(s1, s0);

      //
      s2 = *(__m64 *)src2;
      s6 = *(__m64 *)src6;

      s2 = _mm_adds_pi16(s2, s6);

      s3 = *(__m64 *)src3;
      s5 = *(__m64 *)src5;
      
      s3 = _mm_adds_pi16(s3, s5);

      s7 = _mm_unpackhi_pi16(s3, s2);
      s3 = _mm_unpacklo_pi16(s3, s2);

      //
      s8 = _mm_madd_pi16(s8, c0);
      s7 = _mm_madd_pi16(s7, c1);
      s8 = _mm_add_pi32(s8, s7);
      
      s1 = _mm_madd_pi16(s1, c0);
      s3 = _mm_madd_pi16(s3, c1);
      s3 = _mm_add_pi32(s3, s1);
      
      s4 = *(__m64 *)src4;
      
      s2 = _mm_cmpeq_pi32(s2, s2);
      s2 = _mm_srli_pi16(s2, 15);
      
      s0 = _mm_unpackhi_pi16(s2, s4);
      s2 = _mm_unpacklo_pi16(s2, s4);

      s0 = _mm_madd_pi16(s0, c2);
      s2 = _mm_madd_pi16(s2, c2);

      s0 = _mm_add_pi32(s0, s8);
      s2 = _mm_add_pi32(s2, s3);

      s0 = _mm_srai_pi32(s0, 15);
      s2 = _mm_srai_pi32(s2, 15);

      s2 = _mm_packs_pi32(s2, s0);
      *(__m64 *)dst0 = s2;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      src5 += 4;
      src6 += 4;
      src7 += 4;
      src8 += 4;     
      dst0 += 4;
    }
    //̂
    for( ; j>0; --j){
      tmp = *src0 + *src8;
      tmp = (*src1 + *src7) * 2285 - (tmp * 766);
      tmp = (*src2 + *src6) * 4237 - tmp;
      tmp = (*src3 + *src5) * 5907 - tmp;
      *dst0 = (tmp + *src4 * 26390 + (1<<14)) >> 15;
      
      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;      
      dst0++;
    }
  }
  for( ; i<h; i++){
    dst0 = (short *)(dst + i * max_w);
    src4 = (short *)(src + i * max_w);
    memcpy(dst0, src4, max_w * sizeof(PIXEL_YC));
  }
  
  _mm_empty();

  return 0;
}

// 11tap LPF w/ MMX
int lpf_v_11_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
   int i,j;
  int l0,l1,l2,l3,l4,l6,l7,l8,l9,la;
  short *src0, *src1, *src2, *src3, *src4, *src5;
  short *src6, *src7, *src8, *src9, *srca, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, sa, c0, c1, c2;
  
  c0 = _mm_set_pi16(518, -1442, 518, -1442);
  c1 = _mm_set_pi16(-3993, 2693, -3993, 2693);
  c2 = _mm_set_pi16(27256, 4980, 27256, 4980);
  hb = h - hb;
  w  = w * (sizeof(PIXEL_YC) / sizeof(short));

  for(i=0; i<ht; i++){
    dst0 = (short *)(dst + i * max_w);
    src5 = (short *)(src + i * max_w);
    memcpy(dst0, src5, max_w * sizeof(PIXEL_YC));
  }
  for( ; i<hb; i++){
    dst0 = (short *)(dst + i  * max_w);
    src5 = (short *)(src + i  * max_w);
    if(i-5<0 || i+5>=h){ //͈͊OQƂꍇ
      l4 =i>0 ? i-1 : 0;
      l6 = i<(h-1) ? i+1 : h-1;
      l3 = (i-1)>0 ? i-2 : l4;
      l7 = i<(h-2) ? i+2 : l6;
      l2 = (i-2)>0 ? i-3 : l3;
      l8 = i<(h-3) ? i+3 : l7;
      l1 = (i-3)>0 ? i-4 : l2;
      l9 = i<(h-4) ? i+4 : l8;
      l0 = (i-4)>0 ? i-5 : l1;
      la = i<(h-5) ? i+5 : l9;
     
      src0 = (short *)(src + l0 * max_w);
      src1 = (short *)(src + l1 * max_w);
      src2 = (short *)(src + l2 * max_w);
      src3 = (short *)(src + l3 * max_w);
      src4 = (short *)(src + l4 * max_w);
      src6 = (short *)(src + l6 * max_w);
      src7 = (short *)(src + l7 * max_w);
      src8 = (short *)(src + l8 * max_w);
      src9 = (short *)(src + l9 * max_w);
      srca = (short *)(src + la * max_w);
    }else{
      src0 = (short *)(src + (i-5) * max_w);
      src1 = (short *)(src + (i-4) * max_w);
      src2 = (short *)(src + (i-3) * max_w);
      src3 = (short *)(src + (i-2) * max_w);
      src4 = (short *)(src + (i-1) * max_w);
      src6 = (short *)(src + (i+1) * max_w);
      src7 = (short *)(src + (i+2) * max_w);
      src8 = (short *)(src + (i+3) * max_w);
      src9 = (short *)(src + (i+4) * max_w);
      srca = (short *)(src + (i+5) * max_w);
    }
    
    for(j=w; j>3; j-=4){
      //
      s0 = *(__m64 *)src0;
      sa = *(__m64 *)srca;
      s0 = _mm_adds_pi16(s0, sa);
      
      s1 = *(__m64 *)src1;
      s9 = *(__m64 *)src9;
      s1 = _mm_adds_pi16(s1, s9);

      s9 = _mm_unpackhi_pi16(s1, s0);
      s1 = _mm_unpacklo_pi16(s1, s0);

      s9 = _mm_madd_pi16(s9, c0);
      s1 = _mm_madd_pi16(s1, c0);
      
      sa = _mm_cmpeq_pi32(sa, sa);
      sa = _mm_srli_pi32(sa, 31);
      sa = _mm_slli_pi32(sa, 14);

      s9 = _mm_add_pi32(s9, sa);
      s1 = _mm_add_pi32(s1, sa);
      
      //
      s2 = *(__m64 *)src2;
      s8 = *(__m64 *)src8;
      s2 = _mm_adds_pi16(s2, s8);

      s3 = *(__m64 *)src3;
      s7 = *(__m64 *)src7;
      s3 = _mm_adds_pi16(s3, s7);
      
      s8 = _mm_unpackhi_pi16(s2, s3);
      s2 = _mm_unpacklo_pi16(s2, s3);

      s8 = _mm_madd_pi16(s8, c1);
      s2 = _mm_madd_pi16(s2, c1);

      s9 = _mm_add_pi32(s9, s8);
      s1 = _mm_add_pi32(s1, s2);

      //
      s4 = *(__m64 *)src4;
      s6 = *(__m64 *)src6;
      s4 = _mm_adds_pi16(s4, s6);
      
      s5 = *(__m64 *)src5;
      s6 = _mm_unpackhi_pi16(s4, s5);
      s4 = _mm_unpacklo_pi16(s4, s5);
      
      s6 = _mm_madd_pi16(s6, c2);
      s4 = _mm_madd_pi16(s4, c2);

      s9 = _mm_add_pi32(s9, s6);
      s1 = _mm_add_pi32(s1, s4);

      s9 = _mm_srai_pi32(s9, 15);
      s1 = _mm_srai_pi32(s1, 15);

      s1 = _mm_packs_pi32(s1, s9);
      *(__m64 *)dst0 = s1;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      src5 += 4;
      src6 += 4;
      src7 += 4;
      src8 += 4;
      src9 += 4;
      srca += 4;
      dst0 += 4;
    }
    //̂
    for( ; j>0; --j){
      tmp = *src0 + *srca;
      tmp = (*src1 + *src9) * 1442 - (tmp * 518);
      tmp = (*src2 + *src8) * 2693 - tmp;
      tmp = (*src3 + *src7) * 3993 - tmp;
      tmp = (*src4 + *src6) * 4980 - tmp;
      *dst0 = (tmp + *src5 * 27256 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;
      src9++;
      srca++;     
      dst0++;
    }
  }
  for( ; i<h; i++){
    dst0 = (short *)(dst + i * max_w);
    src5 = (short *)(src + i * max_w);
    memcpy(dst0, src5, max_w * sizeof(PIXEL_YC));
  }

  _mm_empty();

  return 0;
}

// 13tap LPF
int lpf_v_13_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l2,l3,l4,l5,l7,l8,l9,la,lb,lc;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6;
  short *src7, *src8, *src9, *srca, *srcb, *srcc, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, sa, sb, sc, c0, c1, c2, c3;

  c0 = _mm_set_pi16(-363, 981, -363, 981);
  c1 = _mm_set_pi16(-1841, 2822, -1841, 2822);
  c2 = _mm_set_pi16(-3737, 4389, -3737, 4389);
  c3 = _mm_set_pi16(28266, 1<<14, 28266, 1<<14);
  hb = h - hb;
  w  = w * (sizeof(PIXEL_YC) / sizeof(short));
  
  for(i=0; i<ht; i++){
    dst0 = (short *)(dst + i * max_w);
    src6 = (short *)(src + i * max_w);
    memcpy(dst0, src6, max_w * sizeof(PIXEL_YC));
  }
  for( ; i<hb; i++){
    dst0 = (short *)(dst + i  * max_w);
    src6 = (short *)(src + i  * max_w);
    if(i-6<0 || i+6>=h){ //͈͊OQƂꍇ
      l5 = i>0 ? i-1 : 0;
      l7 = i<(h-1) ? i+1 : h-1;
      l4 = (i-1)>0 ? i-2 : l5;
      l8 = i<(h-2) ? i+2 : l7;
      l3 = (i-2)>0 ? i-3 : l4;
      l9 = i<(h-3) ? i+3 : l8;
      l2 = (i-3)>0 ? i-4 : l3;
      la = i<(h-4) ? i+4 : l9;
      l1 = (i-4)>0 ? i-5 : l2;
      lb = i<(h-5) ? i+5 : la;    
      l0 = (i-5)>0 ? i-6 : l1;
      lc = i<(h-6) ? i+6 : lb;
    
      src0 = (short *)(src + l0 * max_w);
      src1 = (short *)(src + l1 * max_w);
      src2 = (short *)(src + l2 * max_w);
      src3 = (short *)(src + l3 * max_w);
      src4 = (short *)(src + l4 * max_w);
      src5 = (short *)(src + l5 * max_w);
      src7 = (short *)(src + l7 * max_w);
      src8 = (short *)(src + l8 * max_w);
      src9 = (short *)(src + l9 * max_w);
      srca = (short *)(src + la * max_w);
      srcb = (short *)(src + lb * max_w);
      srcc = (short *)(src + lc * max_w);
    }else{
      src0 = (short *)(src + (i-6) * max_w);
      src1 = (short *)(src + (i-5) * max_w);
      src2 = (short *)(src + (i-4) * max_w);
      src3 = (short *)(src + (i-3) * max_w);
      src4 = (short *)(src + (i-2) * max_w);
      src5 = (short *)(src + (i-1) * max_w);
      src7 = (short *)(src + (i+1) * max_w);
      src8 = (short *)(src + (i+2) * max_w);
      src9 = (short *)(src + (i+3) * max_w);
      srca = (short *)(src + (i+4) * max_w);
      srcb = (short *)(src + (i+5) * max_w);
      srcc = (short *)(src + (i+6) * max_w);
    }
    
    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      sc = *(__m64 *)srcc;

      s0 = _mm_adds_pi16(s0, sc);

      s1 = *(__m64 *)src1;
      sb = *(__m64 *)srcb;
      
      s1 = _mm_adds_pi16(s1, sb);

      sc = _mm_unpackhi_pi16(s1, s0);
      s1 = _mm_unpacklo_pi16(s1, s0);

      sc = _mm_madd_pi16(sc, c0);
      s1 = _mm_madd_pi16(s1, c0);

      //
      s2 = *(__m64 *)src2;
      sa = *(__m64 *)srca;

      s2 = _mm_adds_pi16(s2, sa);

      s3 = *(__m64 *)src3;
      s9 = *(__m64 *)src9;
      
      s3 = _mm_adds_pi16(s3, s9);

      sa = _mm_unpackhi_pi16(s3, s2);
      s3 = _mm_unpacklo_pi16(s3, s2);

      sa = _mm_madd_pi16(sa, c1);
      s3 = _mm_madd_pi16(s3, c1);
      
      sc = _mm_add_pi32(sc, sa);
      s1 = _mm_add_pi32(s1, s3);

      //
      s4 = *(__m64 *)src4;
      s8 = *(__m64 *)src8;

      s4 = _mm_adds_pi16(s4, s8);

      s5 = *(__m64 *)src5;
      s7 = *(__m64 *)src7;
      
      s5 = _mm_adds_pi16(s5, s7);

      s8 = _mm_unpackhi_pi16(s5, s4);
      s5 = _mm_unpacklo_pi16(s5, s4);

      s8 = _mm_madd_pi16(s8, c2);
      s5 = _mm_madd_pi16(s5, c2);
      
      sc = _mm_add_pi32(sc, s8);
      s1 = _mm_add_pi32(s1, s5);

      //
      s6 = *(__m64 *)src6;
      
      s2 = _mm_cmpeq_pi32(s2, s2);
      s2 = _mm_srli_pi16(s2, 15);
      
      s0 = _mm_unpackhi_pi16(s2, s6);
      s2 = _mm_unpacklo_pi16(s2, s6);

      s0 = _mm_madd_pi16(s0, c3);
      s2 = _mm_madd_pi16(s2, c3);

      s0 = _mm_add_pi32(s0, sc);
      s2 = _mm_add_pi32(s2, s1);

      s0 = _mm_srai_pi32(s0, 15);
      s2 = _mm_srai_pi32(s2, 15);

      s2 = _mm_packs_pi32(s2, s0);
      *(__m64 *)dst0 = s2;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      src5 += 4;
      src6 += 4;
      src7 += 4;
      src8 += 4;
      src9 += 4;
      srca += 4;
      srcb += 4;
      srcc += 4;     
      dst0 += 4;
    }
    for( ; j>0; --j){
      tmp = *src0 + *srcc;
      tmp = (*src1 + *srcb) * 981 - (tmp * 363);
      tmp = (*src2 + *srca) * 1841 - tmp;
      tmp = (*src3 + *src9) * 2822 - tmp;
      tmp = (*src4 + *src8) * 3737 - tmp;
      tmp = (*src5 + *src7) * 4389 - tmp;
      *dst0 = (tmp + *src6 * 28266 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;
      src9++;
      srca++;
      srcb++;
      srcc++;     
      dst0++;
    }
  }
  for( ; i<h; i++){
    dst0 = (short *)(dst + i * max_w);
    src6 = (short *)(src + i * max_w);
    memcpy(dst0, src6, max_w * sizeof(PIXEL_YC));
  }

  _mm_empty();

  return 0;
}

// 15tap LPF
int lpf_v_15_mmx(PIXEL_YC *dst, PIXEL_YC *src, int h, int ht, int hb, int max_w, int w)
{
  int i,j;
  int l0,l1,l2,l3,l4,l5,l6,l8,l9,la,lb,lc,ld,le;
  short *src0, *src1, *src2, *src3, *src4, *src5, *src6, *src7;
  short *src8, *src9, *srca, *srcb, *srcc, *srcd, *srce, *dst0;
  int tmp;
  __m64 s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, sa, sb, sc, sd, se, c0, c1, c2, c3;

  c0 = _mm_set_pi16(265, -695, 265, -695);
  c1 = _mm_set_pi16(-2021, 1299, -2021, 1299);
  c2 = _mm_set_pi16(-3417, 2766, -3417, 2766);
  c3 = _mm_set_pi16(3862, 28650, 3862, 28650);
  hb = h - hb;
  w  = w * (sizeof(PIXEL_YC) / sizeof(short));
  
  for(i=0; i<ht; i++){
    dst0 = (short *)(dst + i * max_w);
    src7 = (short *)(src + i * max_w);
    memcpy(dst0, src7, max_w * sizeof(PIXEL_YC));
  }
  for( ; i<hb; i++){
    dst0 = (short *)(dst + i * max_w);
    src7 = (short *)(src + i * max_w);
    if(i-7<0 || i+7>=h){ //͈͊OQƂꍇ
      l6 = i>0 ? i-1 : 0;
      l8 = i<(h-1) ? i+1 : h-1;
      l5 = (i-1)>0 ? i-2 : l6;
      l9 = i<(h-2) ? i+2 : l8;
      l4 = (i-2)>0 ? i-3 : l5;
      la = i<(h-3) ? i+3 : l9;
      l3 = (i-3)>0 ? i-4 : l4;
      lb = i<(h-4) ? i+4 : la;
      l2 = (i-4)>0 ? i-5 : l3;
      lc = i<(h-5) ? i+5 : lb;    
      l1 = (i-5)>0 ? i-6 : l2;
      ld = i<(h-6) ? i+6 : lc;
      l0 = (i-6)>0 ? i-7 : l1;
      le = i<(h-7) ? i+7 : ld;
      
      src0 = (short *)(src + l0 * max_w);
      src1 = (short *)(src + l1 * max_w);
      src2 = (short *)(src + l2 * max_w);
      src3 = (short *)(src + l3 * max_w);
      src4 = (short *)(src + l4 * max_w);
      src5 = (short *)(src + l5 * max_w);
      src6 = (short *)(src + l6 * max_w);
      src8 = (short *)(src + l8 * max_w);
      src9 = (short *)(src + l9 * max_w);
      srca = (short *)(src + la * max_w);
      srcb = (short *)(src + lb * max_w);
      srcc = (short *)(src + lc * max_w);
      srcd = (short *)(src + ld * max_w);
      srce = (short *)(src + le * max_w);
    }else{
      src0 = (short *)(src + (i-7) * max_w);
      src1 = (short *)(src + (i-6) * max_w);
      src2 = (short *)(src + (i-5) * max_w);
      src3 = (short *)(src + (i-4) * max_w);
      src4 = (short *)(src + (i-3) * max_w);
      src5 = (short *)(src + (i-2) * max_w);
      src6 = (short *)(src + (i-1) * max_w);
      src8 = (short *)(src + (i+1) * max_w);
      src9 = (short *)(src + (i+2) * max_w);
      srca = (short *)(src + (i+3) * max_w);
      srcb = (short *)(src + (i+4) * max_w);
      srcc = (short *)(src + (i+5) * max_w);
      srcd = (short *)(src + (i+6) * max_w);
      srce = (short *)(src + (i+7) * max_w);
    }
    
    for(j=w; j>3; j-=4){
      s0 = *(__m64 *)src0;
      se = *(__m64 *)srce;
      s0 = _mm_adds_pi16(s0, se);
      
      s1 = *(__m64 *)src1;
      sd = *(__m64 *)srcd;
      s1 = _mm_adds_pi16(s1, sd);

      se = _mm_unpackhi_pi16(s1, s0);
      s1 = _mm_unpacklo_pi16(s1, s0);

      se = _mm_madd_pi16(se, c0);
      s1 = _mm_madd_pi16(s1, c0);
      
      sd = _mm_cmpeq_pi32(sd, sd);
      sd = _mm_srli_pi32(sd, 31);
      sd = _mm_slli_pi32(sd, 14);

      se = _mm_add_pi32(se, sd);
      s1 = _mm_add_pi32(s1, sd);
      
      //
      s2 = *(__m64 *)src2;
      sc = *(__m64 *)srcc;
      s2 = _mm_adds_pi16(s2, sc);

      s3 = *(__m64 *)src3;
      sb = *(__m64 *)srcb;
      s3 = _mm_adds_pi16(s3, sb);
      
      sc = _mm_unpackhi_pi16(s2, s3);
      s2 = _mm_unpacklo_pi16(s2, s3);

      sc = _mm_madd_pi16(sc, c1);
      s2 = _mm_madd_pi16(s2, c1);

      se = _mm_add_pi32(se, sc);
      s1 = _mm_add_pi32(s1, s2);

      //
      s4 = *(__m64 *)src4;
      sa = *(__m64 *)srca;
      s4 = _mm_adds_pi16(s4, sa);
      
      s5 = *(__m64 *)src5;
      s9 = *(__m64 *)src9;
      s5 = _mm_adds_pi16(s5, s9);
      
      sa = _mm_unpackhi_pi16(s4, s5);
      s4 = _mm_unpacklo_pi16(s4, s5);

      sa = _mm_madd_pi16(sa, c2);
      s4 = _mm_madd_pi16(s4, c2);

      se = _mm_add_pi32(se, sa);
      s1 = _mm_add_pi32(s1, s4);

      //
      s6 = *(__m64 *)src6;
      s8 = *(__m64 *)src8;
      s6 = _mm_adds_pi16(s6, s8);
      
      s7 = *(__m64 *)src7;
      
      s8 = _mm_unpackhi_pi16(s7, s6);
      s7 = _mm_unpacklo_pi16(s7, s6);
      
      s8 = _mm_madd_pi16(s8, c3);
      s7 = _mm_madd_pi16(s7, c3);

      se = _mm_add_pi32(se, s8);
      s1 = _mm_add_pi32(s1, s7);

      se = _mm_srai_pi32(se, 15);
      s1 = _mm_srai_pi32(s1, 15);

      s1 = _mm_packs_pi32(s1, se);
      *(__m64 *)dst0 = s1;

      src0 += 4;
      src1 += 4;
      src2 += 4;
      src3 += 4;
      src4 += 4;
      src5 += 4;
      src6 += 4;
      src7 += 4;
      src8 += 4;
      src9 += 4;
      srca += 4;
      srcb += 4;
      srcc += 4;
      srcd += 4;
      srce += 4;
      dst0 += 4;
    }
    for( ; j>0; --j){
      tmp = *src0 + *srce;
      tmp = (*src1 + *srcd) * 695 - (tmp * 265);
      tmp = (*src2 + *srcc) * 1299 - tmp;
      tmp = (*src3 + *srcb) * 2021 - tmp;
      tmp = (*src4 + *srca) * 2766 - tmp;
      tmp = (*src5 + *src9) * 3417 - tmp;
      tmp = (*src6 + *src8) * 3862 - tmp;
      *dst0 = (tmp + *src7 * 28650 + (1<<14)) >> 15;

      src0++;
      src1++;
      src2++;
      src3++;
      src4++;
      src5++;
      src6++;
      src7++;
      src8++;
      src9++;
      srca++;
      srcb++;
      srcc++;
      srcd++;
      srce++;
      dst0++;
    }
  }
  for( ; i<h; i++){
    dst0 = (short *)(dst + i * max_w);
    src7 = (short *)(src + i * max_w);
    memcpy(dst0, src7, max_w * sizeof(PIXEL_YC));
  }

  _mm_empty();

  return 0;
}

